package ch.epfl.ppo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class MultiplesFilteringIterator extends FilteringIterator<Integer> {
    private final List<Integer> produced = new ArrayList<>();

    public MultiplesFilteringIterator(Iterator<Integer> underlyingIt) {
        super(underlyingIt);
    }

    @Override
    public Integer next() {
        Integer n = super.next();
        produced.add(n);
        return n;
    }

    @Override
    public boolean shouldInclude(Integer elem) {
        for (int p: produced) {
            if (elem % p == 0)
                return false;
        }
        return true;
    }
}
